import graphene
from aleksis.apps.kolego.models.absence import AbsenceReason
from aleksis.apps.kolego.schema.absence import AbsenceReasonType
from ..models import ExtraMark
from .personal_note import ExtraMarkType

class AbsenceReasonWithCountType(graphene.ObjectType):
    absence_reason = graphene.Field(AbsenceReasonType)
    count = graphene.Int()

    def resolve_count(root, info):
        return 6

class ExtraMarkWithCountType(graphene.ObjectType):
    extra_mark = graphene.Field(ExtraMarkType)
    count = graphene.Int()

    def resolve_count(root, info):
        return 7

class StatisticsByPersonType(graphene.ObjectType):
    participation_count = graphene.Int()
    absence_count = graphene.Int()
    absence_reasons = graphene.List(AbsenceReasonWithCountType)
    tardiness_sum = graphene.Int()
    tardiness_count = graphene.Int()
    extra_marks = graphene.List(ExtraMarkWithCountType)

    def resolve_participation_count(root, info):
        return 3

    def resolve_absence_count(root, info):
        return 1

    def resolve_absence_reasons(root, info):
        # TODO: Return actual AbsenceReasons
        #       Needed by resolve_absence_count as well.
        return AbsenceReason.objects.all()

    def resolve_tardiness_sum(root, info):
        return 17

    def resolve_tardiness_count(root, info):
        return 5

    def resolve_extra_marks(root, info):
        # TODO: Return actual ExtraMarks
        return ExtraMark.objects.all()
